Index: trunk/src/org/expeditee/items/Text.java
===================================================================
--- trunk/src/org/expeditee/items/Text.java	(revision 1414)
+++ trunk/src/org/expeditee/items/Text.java	(revision 1415)
@@ -409,5 +409,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.WIDTH_TO_SAVE_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.WIDTH_TO_SAVE_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.WIDTH_TO_SAVE_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -432,5 +433,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -453,4 +455,6 @@
 			return this.getPrimary().getWidth();
 		} else {
+			if (_width == null || _width <= 0)
+				return null;
 			return _width;
 		}
@@ -458,8 +462,11 @@
 
 	public Integer getAbsoluteWidth() {
-		if (_width == null) {
+		if (_width == null || _width == Integer.MIN_VALUE) {
+			// When absoluting Integer.MIN_VALUE, the java API is defined to give you back Integer.MIN_VALUE!!?!
+			// This is because of the asymmetry of two's complement integer representation.
+			// We would prefer to use Integer.MAX_VALUE in this circumstance.
 			return Integer.MAX_VALUE;
 		}
-
+		
 		return Math.abs(_width);
 	}
@@ -469,4 +476,6 @@
 			return this.getPrimary().getMinWidth();
 		} else {
+			if (_minWidth == null || _minWidth <= 0)
+				return null;
 			return _minWidth;
 		}
@@ -513,5 +522,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.JUSTIFICATION_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.JUSTIFICATION_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.JUSTIFICATION_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -694,5 +704,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.TEXT_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.TEXT_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.TEXT_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -1327,10 +1338,11 @@
 
 		invalidateAll();
-		
+				
 		if (isSurrogate()) {
 			surrogatePropertyInheritance.put(DefaultFrameWriter.FONT_STR, false);
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.FONT_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.FONT_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.FONT_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -1554,5 +1566,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.SPACING_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.SPACING_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -1595,5 +1608,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.WORD_SPACING_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.WORD_SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.WORD_SPACING_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -1626,5 +1640,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LETTER_SPACING_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.LETTER_SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.LETTER_SPACING_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -1650,5 +1665,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.INITIAL_SPACING_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.INITIAL_SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.INITIAL_SPACING_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -1777,8 +1793,8 @@
 
 		int minX = Integer.MAX_VALUE;
-		int maxX = Integer.MIN_VALUE;
+		int maxX = Integer.MIN_VALUE + 1; // +1 makes it safe to do math.abs on
 
 		int minY = Integer.MAX_VALUE;
-		int maxY = Integer.MIN_VALUE;
+		int maxY = Integer.MIN_VALUE + 1; // +1 makes it safe to do math.abs on
 
 		float y = -1;
@@ -1892,5 +1908,5 @@
 				return;
 			}
-			for (Item item : DisplayController.getCurrentFrame().getItems()) {
+			for (Item item : DisplayController.getCurrentFrame().getSortedItems()) {
 				if (item instanceof Line) {
 					lines.add(new org.expeditee.core.Line(((Line) item).getStartItem().getPosition(),
@@ -1914,5 +1930,5 @@
 		}
 
-		float width = Float.MAX_VALUE;
+		float width = (float) Integer.MAX_VALUE;
 		if (limitWidth) {
 			if (_width == null) {
@@ -1945,5 +1961,5 @@
 							paintFont,
 							new Point(getX(), getY()), lines != null ? lines.toArray(new org.expeditee.core.Line[1]) : null,
-							paintFont.getSize() > MINIMUM_FONT_SIZE ? (int) width : (int) Float.MAX_VALUE, 
+							paintFont.getSize() > MINIMUM_FONT_SIZE ? (int) width : Integer.MAX_VALUE, 
 							(int) getSpacing(), 
 							true, 
@@ -2553,5 +2569,5 @@
 				Integer width = getWidth();
 				if (width == null || width < 0) {
-					setWidth(Integer.MIN_VALUE + 1);
+					setWidth(Integer.MIN_VALUE + 1); // +1 makes it safe to do math.abs on
 				}
 			} else if (frameWidth - getX() > ADJUST_WIDTH_THRESHOLD) {
@@ -2866,5 +2882,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_LEFT_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_LEFT_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_LEFT_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -2900,5 +2917,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_RIGHT_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_RIGHT_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_RIGHT_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -2941,5 +2959,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_TOP_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_TOP_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_TOP_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -2987,5 +3006,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_BOTTOM_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_BOTTOM_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.ANCHOR_BOTTOM_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -3101,8 +3121,8 @@
 	//
 	// int min_xl = Integer.MAX_VALUE;
-	// int max_xr = Integer.MIN_VALUE;
+	// int max_xr = Integer.MIN_VALUE + 1; // +1 makes it safe to do math.abs on
 	//
 	// int min_yt = Integer.MAX_VALUE;
-	// int max_yb = Integer.MIN_VALUE;
+	// int max_yb = Integer.MIN_VALUE + 1; // +1 makes it safe to do math.abs on
 	//
 	//
@@ -3168,5 +3188,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.AUTO_WRAP_TO_SAVE_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.AUTO_WRAP_TO_SAVE_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.AUTO_WRAP_TO_SAVE_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -3307,5 +3328,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MASK_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.MASK_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.MASK_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -3330,5 +3352,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.PLACEHOLDER_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.PLACEHOLDER_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.PLACEHOLDER_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -3360,5 +3383,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.SINGLE_LINE_ONLY_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, inheritanceCheckOnSave);
 			}
 		}
@@ -3380,5 +3404,6 @@
 			Item primary = getPrimary();
 			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.TAB_INDEX_STR)) {
-				primary.primaryPropertyEncryption.put(DefaultFrameWriter.TAB_INDEX_STR, EncryptionDetail.InheritanceCheckOnSave);
+				EncryptionDetail inheritanceCheckOnSave = new EncryptionDetail(EncryptionDetail.Type.InheritanceCheckOnSave);
+				primary.primaryPropertyEncryption.put(DefaultFrameWriter.TAB_INDEX_STR, inheritanceCheckOnSave);
 			}
 		}
Index: trunk/src/org/expeditee/items/XRayable.java
===================================================================
--- trunk/src/org/expeditee/items/XRayable.java	(revision 1414)
+++ trunk/src/org/expeditee/items/XRayable.java	(revision 1415)
@@ -26,5 +26,4 @@
 import org.expeditee.core.Point;
 import org.expeditee.gui.DisplayController;
-import org.expeditee.gui.FrameGraphics;
 
 public abstract class XRayable extends Item {
Index: trunk/src/org/expeditee/network/FrameShare.java
===================================================================
--- trunk/src/org/expeditee/network/FrameShare.java	(revision 1414)
+++ trunk/src/org/expeditee/network/FrameShare.java	(revision 1415)
@@ -414,5 +414,5 @@
 		
 		List<File> imageFiles = new LinkedList<File>();
-		for(Item i : toSave.getItems()) {
+		for(Item i : toSave.getSortedItems()) {
 			if(i instanceof Picture) {
 				((Picture) i).moveToImagesFolder();
Index: trunk/src/org/expeditee/setting/ArraySetting.java
===================================================================
--- trunk/src/org/expeditee/setting/ArraySetting.java	(revision 1414)
+++ trunk/src/org/expeditee/setting/ArraySetting.java	(revision 1415)
@@ -37,11 +37,9 @@
 	}
 
-    	public T getSafe(int i) {
-		
-		if(i < _value.length){
-			
+    public T getSafe(int i) {
+		if(i < _value.length) {	
 			return _value[i];
 		}
-		else{
+		else {
 			return _default[i];
 		}		
@@ -71,27 +69,34 @@
 		
 		if (_value.length > 0) {
-			Frame arrayFrame = FrameIO.CreateFrame(frameset, null, null);
-			arrayFrame.getTitleItem().delete();
-			
-			int x = 100;
-			int y = 100;
-			for (T v: _value) {
-				if (v == null) continue;
-				Text representation;
-				if (v instanceof Representable) {
-					representation = ((Representable) v).generateRepresentation("Array Entry", "");
-					representation.setPosition(x, y);
-					representation.setID(arrayFrame.getNextItemID());
-					arrayFrame.addItem(representation);
-				} else {
-					representation = arrayFrame.addText(x, y, v.toString(), null);
-				}
-				y += representation.getBoundsHeight();
-			}
-			FrameIO.ForceSaveFrame(arrayFrame);
-			t.setLink(arrayFrame.getName());
+			createChildFrame(frameset, t, null);
 		}
 		
 		return t;
 	}
+
+	protected void createChildFrame(String frameset, Text t, String frameTitle) {
+		Frame arrayFrame = FrameIO.CreateFrame(frameset, frameTitle, null);
+		
+		if (frameTitle != null) {
+			arrayFrame.getTitleItem().delete();
+		}
+		
+		int x = 100;
+		int y = 100;
+		for (T v: _value) {
+			if (v == null) continue;
+			Text representation;
+			if (v instanceof Representable) {
+				representation = ((Representable) v).generateRepresentation("Array Entry", "");
+				representation.setPosition(x, y);
+				representation.setID(arrayFrame.getNextItemID());
+				arrayFrame.addItem(representation);
+			} else {
+				representation = arrayFrame.addText(x, y, v.toString(), null);
+			}
+			y += representation.getBoundsHeight();
+		}
+		FrameIO.ForceSaveFrame(arrayFrame);
+		t.setLink(arrayFrame.getName());
+	}
 }
Index: trunk/src/org/expeditee/settings/Settings.java
===================================================================
--- trunk/src/org/expeditee/settings/Settings.java	(revision 1414)
+++ trunk/src/org/expeditee/settings/Settings.java	(revision 1415)
@@ -21,4 +21,5 @@
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
+import java.util.Collection;
 import java.util.HashMap;
 import java.util.Iterator;
@@ -30,4 +31,6 @@
 import org.expeditee.gui.FrameCreator;
 import org.expeditee.gui.MessageBay;
+import org.expeditee.items.Item;
+import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.Text;
 import org.expeditee.items.widgets.Password;
@@ -194,5 +197,7 @@
 						}
 
-						if(s == null) continue;
+						if(s == null) {
+							continue;
+						}
 						
 						if(validPages.size() > 1) {
@@ -226,4 +231,11 @@
         }
 		
+		// Having parsed this page, we must alter all the items on the frame that they are no longer being shown.
+		// For things such as WidgetCorners, this means that they will be removed from live consideration.
+		Collection<Item> allItems = child.getAllItems();
+		for (Item i: allItems) {
+			i.onParentStateChanged(new ItemParentStateChangedEvent(child, ItemParentStateChangedEvent.EVENT_TYPE_HIDDEN));
+		}
+		
 		// if the page was a settings page, check if it has any subpages
 		for(Text t : child.getTextItems()) {
@@ -275,4 +287,5 @@
 			int x = 0, y = 0;
 			
+			Frame currentFrame = frames.getCurrentFrame();
 			if (key.toLowerCase().equals("pass")) {
 				// Special case for Password widgets
@@ -280,6 +293,6 @@
 				Password pw = new Password(passwordWidgetText, null);
 				pw.setPassword("");
-				frames.getCurrentFrame().removeItem(passwordWidgetText);
-				frames.getCurrentFrame().addAllItems(pw.getItems());
+				currentFrame.removeItem(passwordWidgetText);
+				currentFrame.addAllItems(pw.getItems());
 				x = passwordWidgetText.getX() + passwordWidgetText.getBoundsWidth();
 				y = passwordWidgetText.getY();
@@ -291,9 +304,14 @@
 				// Construct and add text representation for setting.  
 				// If a setting has no initialised value then it is not included.
-				Text settingRepresentation = setting.generateRepresentation(key, frames.getCurrentFrame().getFramesetName()).copy();
-				if (settingRepresentation.getBounds() == null) {
+				String framesetName = currentFrame.getFramesetName();
+				Text template = setting.generateRepresentation(key, framesetName);
+				if (template == null) {
 					continue;
 				}
-				settingRepresentation.setID(frames.getCurrentFrame().getNextItemID());
+				Text settingRepresentation = template.copy();
+				if (settingRepresentation == null || settingRepresentation.getBounds() == null) {
+					continue;
+				}
+				settingRepresentation.setID(currentFrame.getNextItemID());
 				frames.addItem(settingRepresentation, false);				
 				x = settingRepresentation.getX() + settingRepresentation.getBoundsWidth();
@@ -303,5 +321,5 @@
 			x = Math.max(250, x + 20);
 			// Add tooltip for setting
-			Text tooltip = frames.getCurrentFrame().addText(x, y, "// " + setting.getTooltip(), null);
+			Text tooltip = currentFrame.addText(x, y, "// " + setting.getTooltip(), null);
 			tooltip.rebuild(true);
 			if (tooltip.getY() + tooltip.getBoundsHeight() > frames.getLastY()) {
Index: trunk/src/org/expeditee/settings/UserSettings.java
===================================================================
--- trunk/src/org/expeditee/settings/UserSettings.java	(revision 1414)
+++ trunk/src/org/expeditee/settings/UserSettings.java	(revision 1415)
@@ -283,55 +283,4 @@
 	}
 
-//	public static void appendDefaultFolders() {
-//		if (PublicAndPrivateResources && AuthenticatorBrowser.isAuthenticated()) {
-//			// The comments here explain how things have changed with the new regime.
-//			// FrameDirs
-//			// 1. PROFILE_PATH					Still points to same place.
-//			// 2. SHARED_FRAMESETS_PATH			Still points to same place. (encryption stops just anyone reading it)
-//			// 3. framesets-<username>			Generated on user account creation and must be refreshed on user switching.  Also gives access to tutorial stuffs.
-//			// 4. FRAME_PATH					<expeditee-home>\resources-public\framesets.
-//			// 5. HELP_PUBLIC_PATH				<expeditee-home>\resources-public\documentation.
-//			// 6. MESSAGES_PATH					Still points to same place.  Should these be per user and encrypted?
-//			// 7. PUBLIC_PATH					Still points to same place.  Kept for compatibility.
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PROFILE_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PRIVATE_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.SHARED_FRAMESETS_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.RESOURCES_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MESSAGES_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PUBLIC_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PRIVATE_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MAIL_PATH);
-//			FolderSettings.FrameDirs.setDefault(FolderSettings.FrameDirs.get());
-//						
-//			// ImageDirs
-//			// 1. resources-<username>\images	Generated on user account creation and must be refreshed on user switching.
-//			// 2. IMAGES_PATH					<expeditee-home>\resources-public\images
-//			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PRIVATE_PATH);
-//			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PATH);
-//			FolderSettings.ImageDirs.setDefault(FolderSettings.ImageDirs.get());
-//			
-//			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PRIVATE_PATH);
-//			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PATH);
-//			FolderSettings.AudioDirs.setDefault(FolderSettings.AudioDirs.get());
-//		} else {
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PUBLIC_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PROFILE_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PATH);
-//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MESSAGES_PATH);
-//			if (FrameIO.FRAME_PRIVATE_PATH != null) {
-//				FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PRIVATE_PATH);
-//			}
-//			FolderSettings.FrameDirs.setDefault(FolderSettings.FrameDirs.get());
-//			
-//			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PATH);
-//			FolderSettings.ImageDirs.setDefault(FolderSettings.ImageDirs.get());
-//			
-//			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PATH);
-//			FolderSettings.AudioDirs.setDefault(FolderSettings.AudioDirs.get());
-//		}
-//	}
-
 	/**
 	 * Find the appropriate directory to store application settings in for
Index: trunk/src/org/expeditee/settings/identity/secrets/KeyList.java
===================================================================
--- trunk/src/org/expeditee/settings/identity/secrets/KeyList.java	(revision 1414)
+++ trunk/src/org/expeditee/settings/identity/secrets/KeyList.java	(revision 1415)
@@ -1,8 +1,14 @@
 package org.expeditee.settings.identity.secrets;
 
+import java.util.List;
+import java.util.function.Predicate;
+
+import org.expeditee.gui.Frame;
 import org.expeditee.items.Text;
+import org.expeditee.setting.ArraySetting;
 import org.expeditee.setting.TextSetting;
 
 public class KeyList {
+	
 	public static final TextSetting PersonalKey = new TextSetting("The AES key used to secure your profile frame - do not share with anyone!", "PersonalKey") {	
 		@Override
@@ -20,3 +26,34 @@
 		}
 	};
+	
+	public static final ArraySetting<Text> UserLabels = new ArraySetting<Text>("The labels (and their associated keys) that you have either created or recieved.", 
+			"UserLabels", new Text[] { }) {
+		
+		@Override
+		public boolean setSetting(Text text) {
+			Frame child = text.getChild();
+    		if (child == null) {
+    			return false;
+    		}
+    		
+    		Predicate<Text> hasNoData = t -> { 
+    			List<String> data = t.getData();
+    			return data == null || data.isEmpty();
+    		};
+    		List<Text> textItems = child.getBodyTextItems(false);
+    		textItems.removeIf(hasNoData);
+    		_value = textItems.toArray(new Text[] {});
+    		
+    		return true;
+		}
+		
+		@Override
+		public Text generateRepresentation(String label, String frameset) {
+			Text t = new Text(label);
+			
+			createChildFrame(frameset, t, "My Labels");
+			
+			return t;
+		}
+	};
 }
Index: trunk/src/org/expeditee/stats/TreeStats.java
===================================================================
--- trunk/src/org/expeditee/stats/TreeStats.java	(revision 1414)
+++ trunk/src/org/expeditee/stats/TreeStats.java	(revision 1415)
@@ -57,5 +57,5 @@
 		_treeFrames = 1;
 		// Now get all add all the trees for linked items
-		for (Item i : topFrame.getItems()) {
+		for (Item i : topFrame.getSortedItems()) {
 			String link = i.getAbsoluteLink();
 			if (link == null)
